import ConcurrentError from './concurrent-error';
import { ResourceAlreadyExistError, ResourceNotExistError } from './resource-errors';
import { EventstoreFrozenError, AlreadyFrozenError, AlreadyUnfrozenError } from './frozen-errors';
import { ReplicationAlreadyInProgress } from './replication-errors';
import getNextCursor from './get-next-cursor';
import throwBadCursor from './throw-bad-cursor';
import snapshotTrigger from './snapshot-trigger';
import * as iots from 'io-ts';
import * as iotsTypes from 'io-ts-types';
import { validate, UnbrandProps, CursorFilter, TimestampFilter, isTimestampFilter, isCursorFilter, Adapter, AdapterFunctions, AdapterPoolConnectedProps, AdapterPoolPossiblyUnconnected, AdapterPoolConnected, AdapterConfig, AdapterConfigSchema } from './types';
export { threadArrayToCursor, cursorToThreadArray, initThreadArray, } from './cursor-operations';
export { MAINTENANCE_MODE_AUTO, MAINTENANCE_MODE_MANUAL, THREAD_COUNT, CURSOR_BUFFER_SIZE, THREAD_COUNTER_BYTE_LENGTH, } from './constants';
declare const wrappedCreateAdapter: <ConnectedProps extends AdapterPoolConnectedProps, ConnectionDependencies extends unknown, Config extends UnbrandProps<{
    snapshotBucketSize?: iots.Branded<number, iots.IntBrand> | undefined;
}>>(adapterFunctions: AdapterFunctions<ConnectedProps, ConnectionDependencies, Config>, connectionDependencies: ConnectionDependencies, options: Config) => Adapter;
export default wrappedCreateAdapter;
export { validate, UnbrandProps, ResourceAlreadyExistError as EventstoreResourceAlreadyExistError, ResourceNotExistError as EventstoreResourceNotExistError, ConcurrentError, EventstoreFrozenError, AlreadyFrozenError as EventstoreAlreadyFrozenError, AlreadyUnfrozenError as EventstoreAlreadyUnfrozenError, ReplicationAlreadyInProgress, throwBadCursor, getNextCursor, snapshotTrigger, CursorFilter, TimestampFilter, isTimestampFilter, isCursorFilter, Adapter, AdapterPoolConnectedProps, AdapterPoolConnected, AdapterPoolPossiblyUnconnected, AdapterConfig, AdapterConfigSchema, iots, iotsTypes, };
export { ImportOptions, ExportOptions, SecretFilter, SecretsWithIdx, SecretRecord, InputEvent, SavedEvent, EventThreadData, Cursor, EventsWithCursor, EventFilter, ReplicationStatus, ReplicationState, OldEvent, OldSecretRecord, getInitialReplicationState, } from './types';
export { makeSetSecretEvent, makeDeleteSecretEvent, DELETE_SECRET_EVENT_TYPE, SET_SECRET_EVENT_TYPE, } from './secret-event';
